var { moralis_config, reids_token_config, account_config, timer_config } = require('../config/config.js')
const redis = require("./db/redis_db")  //导入 db.js
const mysql = require("./db/mysql_db")
const moralis = require("./moralis_sdk")  //导入 db.js
var utils = require('./utils.js');
const logger = require('./logger')


const interval_delay_time = 5000;
const start_delay_time = 1000;

// 定时任务，归集操作
// setInterval(timedCollectCoins, 10000)
var index = 0;

if (timer_config.OPEN_TIMED_COLLECT_COINS) {
    setTimeout(async () => {
        while (true) {
            await timedCollectCoins();
            await utils.sleep(interval_delay_time);
        }
    }, start_delay_time);
}

async function exec(element) {
    logger.log('exec in:', element.user_address, element.chain);
    var ret = await moralis.collectCoins({
        chain: element.chain,
        address: element.user_address
    });
    logger.log('exec out:', ret);
}

async function timedCollectCoins() {
    logger.log('timedCollectCoins exec index', index)
    var chainInfos = await mysql.queryAllUserPrivateKeyAndUserAddress();
    // console.log('chainInfo', chainInfo);
    if (chainInfos && Array.isArray(chainInfos) && chainInfos.length > 0) {
        for (var element of chainInfos) {
            if (element.user_address != account_config.WELLET_PUBLIC_KEY) {
                await exec(element);
            }
        }
    }
    index++;
}

